Eclipse Rich Ajax Platform Release 1.3

## org.eclipse.swt.layout
Class FormLayout

    java.lang.Object
      org.eclipse.swt.widgets.Layout
          org.eclipse.swt.layout.FormLayout

public final class FormLayout
extends Layout

Instances of this class control the position and size of the children of a composite control by using `FormAttachments` to optionally configure the left, top, right and bottom edges of each child.

The following example code creates a `FormLayout` and then sets it into a `Shell`:

        Display display = new Display ();
        Shell shell = new Shell(display);
        FormLayout layout = new FormLayout();
        layout.marginWidth = 3;
        layout.marginHeight = 3;
        shell.setLayout(layout);

To use a `FormLayout`, create a `FormData` with `FormAttachment` for each child of `Composite`. The following example code attaches `button1` to the top and left edge of the composite and `button2` to the right edge of `button1` and the top and right edges of the composite:

        FormData data1 = new FormData();
        data1.left = new FormAttachment(0, 0);
        data1.top = new FormAttachment(0, 0);
        button1.setLayoutData(data1);
        FormData data2 = new FormData();
        data2.left = new FormAttachment(button1);
        data2.top = new FormAttachment(0, 0);
        data2.right = new FormAttachment(100, 0);
        button2.setLayoutData(data2);

Each side of a child control can be attached to a position in the parent composite, or to other controls within the `Composite` by creating instances of `FormAttachment` and setting them into the top, bottom, left, and right fields of the child's `FormData`.

If a side is not given an attachment, it is defined as not being attached to anything, causing the child to remain at its preferred size. If a child is given no attachment on either the left or the right or top or bottom, it is automatically attached to the left and top of the composite respectively. The following code positions `button1` and `button2` but relies on default attachments:

        FormData data2 = new FormData();
        data2.left = new FormAttachment(button1);
        data2.right = new FormAttachment(100, 0);
        button2.setLayoutData(data2);

IMPORTANT: Do not define circular attachments. For example, do not attach the right edge of `button1` to the left edge of `button2` and then attach the left edge of `button2` to the right edge of `button1`. This will over constrain the layout, causing undefined behavior. The algorithm will terminate, but the results are undefined.

Since:
  1.0
See Also:
  `FormData`, `FormAttachment`, FormLayout snippets, SWT Example: LayoutExample, Sample code and further information

Field Summary
`int` `marginBottom` marginBottom specifies the number of pixels of vertical margin that will be placed along the bottom edge of the layout.
`int` `marginHeight` marginHeight specifies the number of pixels of vertical margin that will be placed along the top and bottom edges of the layout.
`int` `marginLeft` marginLeft specifies the number of pixels of horizontal margin that will be placed along the left edge of the layout.
`int` `marginRight` marginRight specifies the number of pixels of horizontal margin that will be placed along the right edge of the layout.
`int` `marginTop` marginTop specifies the number of pixels of vertical margin that will be placed along the top edge of the layout.
`int` `marginWidth` marginWidth specifies the number of pixels of horizontal margin that will be placed along the left and right edges of the layout.
`int` `spacing` spacing specifies the number of pixels between the edge of one control and the edge of its neighbouring control.

Constructor Summary
`FormLayout()` Constructs a new instance of this class.

Method Summary
`protected Point` `computeSize(Composite composite, int wHint, int hHint, boolean flushCache)` Computes and returns the size of the specified composite's client area according to this layout.
`protected boolean` `flushCache(Control control)` Instruct the layout to flush any cached values associated with the control specified in the argument `control`.
`protected void` `layout(Composite composite, boolean flushCache)` Lays out the children of the specified composite according to this layout.
`String` `toString()` Returns a string containing a concise, human-readable description of the receiver.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### marginWidth

    public int marginWidth

  marginWidth specifies the number of pixels of horizontal margin that will be placed along the left and right edges of the layout. The default value is 0.

### marginHeight

    public int marginHeight

  marginHeight specifies the number of pixels of vertical margin that will be placed along the top and bottom edges of the layout. The default value is 0.

### marginLeft

    public int marginLeft

  marginLeft specifies the number of pixels of horizontal margin that will be placed along the left edge of the layout. The default value is 0.

### marginTop

    public int marginTop

  marginTop specifies the number of pixels of vertical margin that will be placed along the top edge of the layout. The default value is 0.

### marginRight

    public int marginRight

  marginRight specifies the number of pixels of horizontal margin that will be placed along the right edge of the layout. The default value is 0.

### marginBottom

    public int marginBottom

  marginBottom specifies the number of pixels of vertical margin that will be placed along the bottom edge of the layout. The default value is 0.

### spacing

    public int spacing

  spacing specifies the number of pixels between the edge of one control and the edge of its neighbouring control. The default value is 0.

Constructor Detail

### FormLayout

    public FormLayout()

  Constructs a new instance of this class.

Method Detail

### computeSize

    protected Point computeSize(Composite composite,
                                int wHint,
                                int hHint,
                                boolean flushCache)

  Description copied from class: `Layout`
  Computes and returns the size of the specified composite's client area according to this layout.

  This method computes the size that the client area of the composite must be in order to position all children at their preferred size inside the composite according to the layout algorithm encoded by this layout.

  When a width or height hint is supplied, it is used to constrain the result. For example, if a width hint is provided that is less than the width of the client area, the layout may choose to wrap and increase height, clip, overlap, or otherwise constrain the children.

  Specified by:
    `computeSize` in class `Layout`
  Parameters:
    `composite` - a composite widget using this layout
    `wHint` - width (`SWT.DEFAULT` for preferred size)
    `hHint` - height (`SWT.DEFAULT` for preferred size)
    `flushCache` - `true` means flush cached layout values
  Returns:
    a point containing the computed size (width, height)
  See Also:
    `Layout.layout(org.eclipse.swt.widgets.Composite, boolean)`, `Control.getBorderWidth()`, `Control.getBounds()`, `Control.getSize()`, `Control.pack(boolean)`, "computeTrim, getClientArea for controls that implement them"

### flushCache

    protected boolean flushCache(Control control)

  Description copied from class: `Layout`
  Instruct the layout to flush any cached values associated with the control specified in the argument `control`.

  Overrides:
    `flushCache` in class `Layout`
  Parameters:
    `control` - a control managed by this layout
  Returns:
    true if the Layout has flushed all cached information associated with control

### layout

    protected void layout(Composite composite,
                          boolean flushCache)

  Description copied from class: `Layout`
  Lays out the children of the specified composite according to this layout.

  This method positions and sizes the children of a composite using the layout algorithm encoded by this layout. Children of the composite are positioned in the client area of the composite. The position of the composite is not altered by this method.

  When the flush cache hint is true, the layout is instructed to flush any cached values associated with the children. Typically, a layout will cache the preferred sizes of the children to avoid the expense of computing these values each time the widget is laid out.

  When layout is triggered explicitly by the programmer the flush cache hint is true. When layout is triggered by a resize, either caused by the programmer or by the user, the hint is false.

  Specified by:
    `layout` in class `Layout`
  Parameters:
    `composite` - a composite widget using this layout
    `flushCache` - `true` means flush cached layout values

### toString

    public String toString()

  Returns a string containing a concise, human-readable description of the receiver.

  Returns:
    a string representation of the layout

Eclipse Rich Ajax Platform Release 1.3

Copyright (c) Innoopract Informationssysteme GmbH and others 2002, 2011. All rights reserved.